function[theta_est,phi_est,dic]=dictionary_learning(y,A,Theta_est,Phi_est,N1,N2,dx,dy,X,doa1,doa2)
%N1: numbers of x-line sensors
%N2: numbers of y-line sensors
%U_theta=partial (dx)/partial(theta)
%V_theta=partial (dy)/partial(theta)
%U_phi=partial (dx)/partial(phi)
%V_phi=partial (dy)/partial(phi)

B_x=zeros(N1,length(Theta_est));
B_y=zeros(N2,length(Theta_est));
Theta=Theta_est;
Phi=Phi_est;
itermax=500;
theta_ini=sort(Theta_est,'ascend');
Phi_ini=Phi;
ini=[theta_ini,Phi_ini];
theta_true=doa1;
phi_true=doa2;
True_doa=[theta_true,phi_true];
dic_learning_error=zeros(itermax,2*length(Theta));
for iter=1:itermax
    Theta_est=sort(Theta_est,'ascend');
    for i=1:length(Theta_est)
        step=1;
        Theta_old=Theta_est;
        B_x(:,i)=[0:N1-1]'*cosd(Theta_est(i));
        B_y(:,i)=[0:N2-1]'*cosd(Theta_est(i));
        U_theta(:,i)=1j*pi*cosd(Phi_est(i)).*( B_x(:,i).*dx(:,i));
        V_theta(:,i)=1j*pi*sind(Phi_est(i)).*(B_y(:,i).*dy(:,i));
        A_temp=zeros(size(A));
        A_temp(:,i)=vec(U_theta(:,i)*dy(:,i).')+vec(dx(:,i)*V_theta(:,i).');
        g_theta(i)=2*real(trace((A*X-y)'* A_temp*X));
        while abs(g_theta(i))>10
            g_theta(i)=g_theta(i)/10;
        end
        Theta(i)=Theta_est(i)- step*g_theta(i);
        [D,dx,dy]=construct_dictionary(Theta,Phi,N1,N2);
        counter=0;
        while trace((y-D*X)'*(y-D*X))>trace((y-A*X)'*(y-A*X))&& counter<5
            step=step*0.1;
            Theta(i)=Theta_est(i)- step*g_theta(i);
            [D,dx,dy]=construct_dictionary(Theta,Phi,N1,N2);
            counter=counter+1;
        end
        A=D;
        Theta_est=Theta;
        X=inv(A'*A)*(A'*y);
    end
    for i=1:length(Phi_est)
        step=1;
        Phi_old=Phi_est;
        C_x(:,i)=[0:N1-1]'*sind(Phi_est(i));
        C_y(:,i)=[0:N2-1]'*cosd(Phi_est(i));
        U_phi(:,i)=-1j*pi*sind(Theta_est(i)).*( C_x(:,i).*dx(:,i));
        V_phi(:,i)=1j*pi*sind(Phi_est(i)).*(C_y(:,i).*dy(:,i));
        A_temp=zeros(size(A));
        A_temp(:,i)=(vec(U_phi(:,i)*dy(:,i).')+vec(dx(:,i)*V_phi(:,i).'));
        g_phi(i)=2*real(trace((A*X-y)'* A_temp*X));
        while abs(g_phi(i))>10
            g_phi(i)=g_phi(i)/10;
        end
        Phi(i)=Phi_est(i)- step*g_phi(i);
        [D,dx,dy]=construct_dictionary(Theta_est,Phi,N1,N2);
        counter=0;
        while trace((y-D*X)'*(y-D*X))>trace((y-A*X)'*(y-A*X))&& counter<5
            step=step*0.1;
            Phi(i)=Phi_est(i)- step*g_phi(i);
            [D,dx,dy]=construct_dictionary(Theta_est,Phi,N1,N2);
            counter=counter+1;
        end
        A=D;
        Phi_est=Phi;
        X=inv(A'*A)*(A'*y);
    end
    no_learning_error=[theta_ini,Phi_ini]-True_doa;
    ori=sum(abs(no_learning_error(1,:)));
    dic_learning_error(iter,:)=[Theta_est,Phi_est]-True_doa;
    dic=sum(abs(dic_learning_error(iter,:)));
    [Theta_est,Phi_est];
    stop_flag=0;
    for i=1:length(True_doa)/2
        if abs(Phi_est(i)-Phi_old(i))<1e-4
            stop_flag=stop_flag+1;
        end
        if abs(Theta_est(i)-Theta_old(i))<1e-4
            stop_flag=stop_flag+1;
        end
    end
    
    if stop_flag==length(True_doa)|iter==itermax
        theta_est=Theta_est;
        phi_est=Phi_est;
        dic=sum(abs(dic_learning_error(iter,:)));
        [Theta_est,Phi_est];
        break;
    end
%      aaa(iter,:)=abs([Theta_est,Phi_est]-True_doa);
end
dic;
counter;
end



function [x_out]=vec(x)
x_out=x(:);
end



