function [x_zoom] = zoom_step_2Dtest1(x_out, threshold, Qblock, M, N1,N2, t1,t2, y, alpha,fBlock1old,fBlock2old)

%zooming into BandLasso
predicted_bands = (abs(x_out).^2 > threshold); %find active bands
nr = sum(predicted_bands); % number of predcited bands
fBlock1old = linspace(-0.999,.999,Qblock*M+1);
fBlock2old= linspace(-0.999,.999,Qblock*M+1);
if nr > 0
    loc = find(abs(x_out).^2 > threshold); %location of predicted bands
    loc_new=(loc-1)*(Qblock)*(Qblock)+1;
    x_zoom = zeros(Qblock*(Qblock),Qblock*(Qblock)); %expanded 2D grid
    Azoom = []; %empty dictionary
    for s=1:nr
        [s1, s2] = ind2sub([M M], loc(s)); %location of predicted bands for each dimension
        subBlock1_temp = fBlock1old((s1-1)*Qblock+1:s1*Qblock+1);
        subBlock2_temp  = fBlock2old((s2-1)*Qblock+1:s2*Qblock+1);
        subBlock1 = linspace(subBlock1_temp(1),subBlock1_temp (end),Qblock+1);
        subBlock2 = linspace(subBlock2_temp(1),subBlock2_temp (end),Qblock+1);
        Asub = zeros(N1,Qblock); %subdictionary
        for iM=1:Qblock
            a = 1./(2i*pi*t1).*(exp(2i*pi*t1*(subBlock1(iM+1)))-...
                exp(2i*pi*t1*(subBlock1(iM))));
            Asub(:,iM) =a/norm(a);
        end;
        Asub1 = Asub;
        Asub = zeros(N2,Qblock); %subdictionary
        for iM=1:Qblock
            a = 1./(2i*pi*t2).*(exp(2i*pi*t2*(subBlock2(iM+1)))-...
                exp(2i*pi*t2*(subBlock2(iM))));
            Asub(:,iM) =a/norm(a);
        end;
        Asub2 = Asub;
        Azoom = [Azoom kron(Asub2,Asub1)]; %combine subdictionaries
    end
    
    lambda = alpha*max(max(abs(Azoom'*y)));
    
    
    [x_tmp,objective,iter_stop] = ADMM_Lasso_DOA(y,Azoom,1,lambda,1e-5,1e-5,500); %solve for new dictionary
    xx=x_tmp.*conj(x_tmp);
    
    
    for i=1:nr
        row=mod(loc(i),Qblock);
        col=(loc(i)-row)/Qblock;
        loc_new(i)=col*(Qblock)*(Qblock)*Qblock+(row-1)*(Qblock)+1;
    end
    
    for s=1:nr
        data = x_tmp(Qblock*Qblock*(s-1)+1:Qblock*Qblock*s); %take one block from the solution vector
        if length(nonzeros(data))>1
            data(abs(data)<max(abs(data)))=0;
            ind_find=loc_new(s);
            x_zoom = remap_mtx(x_zoom, Qblock, M, data, ind_find); %remap 1D solution to 2D
        end
    end;
    a=666;
else
    x_zoom = 0;
end;